#include "gr.h"

#define	MODE	0x13
#define	MAXX	320
#define	MAXY	200

#define	MAXCOLOR	63

#define	RN	6
#define	GN	6
#define	BN	4

static int log2(unsigned int x) {
   int i;
   for(i=0;x;i++,x>>=1) ;
   return i;
} /* log2 */
void gr_enummodes(mode_enumerator moden) {
   (*moden)(MAXX,MAXY,log2(RN+1),log2(GN+1),log2(BN+1),1,MODE);
} /* gr_enummodes */

int gr_maxx(void) { return MAXX; }
int gr_maxy(void) { return MAXY; }

void _outportb(int port,int byt);
void setmode(int mode);
int getmode(void);
#ifdef	__WATCOMC__
#pragma	aux	_outport	parm [edx] [eax]="out dx,al";
#pragma	aux	setmode		parm [eax] ="int 10h";
#endif
#ifdef	__BORLANDC__
static void _outportb(int port,int byt) {
_asm	{
	mov	dx,port
	mov	ax,byt
	out	dx,al
}
} /* _outportb */
static void setmode(int mode) {
_asm	{
	mov	ax,mode
	int	10h
}
} /* setmode */
#endif

#define	SCALE(color,max,scalemax)	(((color)*(scalemax))/(max))
static unsigned char rxlate[COLOR_MAX],gxlate[COLOR_MAX],bxlate[COLOR_MAX];
static void setxlate(unsigned char *xlate,int mul,int max) {
   int i,r,x;
   for(i=0;i<COLOR_MAX;i++) {
      x=max*i;
      x=(x+COLOR_LIM/2)/COLOR_LIM;
      if(x>max) x=max;
      xlate[i]=x*mul;
   }
} /* setxlate */
static void setpalette(void) {
   int r,g,b,i;
   for(i=r=0;r<=RN;r++) {
      for(g=0;g<=GN;g++) {
         for(b=0;b<=BN;b++,i++) {
            _outportb(0x3c8,i);
            _outportb(0x3c9,SCALE(r,RN,MAXCOLOR));
            _outportb(0x3c9,SCALE(g,GN,MAXCOLOR));
            _outportb(0x3c9,SCALE(b,BN,MAXCOLOR));
         }
      }
   }
   setxlate(bxlate,1,BN); setxlate(gxlate,BN+1,GN); setxlate(rxlate,(BN+1)*(GN+1),RN);
} /* setpalette */
int  gr_open(int code) {
   setmode(MODE);
   setpalette();
   return 1;	/* Ok! */
} /* gr_open */

void gr_close(void) {
   setmode(0x03);
} /* gr_close */

void gr_redraw(void) {
} /* gr_redraw */

#ifdef	__BORLANDC__
typedef	unsigned char far *scrptr;
static unsigned char far *scrp=(unsigned char far*)0xA0000000UL;
#endif
#ifdef	__WATCOMC__
typedef	unsigned char *scrptr;
static unsigned char *scrp=(unsigned char*)0xA0000;
#endif
void gr_pack(int x,int y,pix*p,int l) {
   int i,r;
   scrptr sp;
   if(y<0 || y>=MAXY) return;
   if(x>=MAXX) return ;
   if(x<0) { x=-x; l+=x; p=&p[x]; x=0;}
   if(l<=0) return ;
   if((l+x)>=MAXX) { l=MAXX-x;}
   sp=&scrp[y*MAXX+x];
   for(i=0;i<l;i++) {
      r=rxlate[p[i].r];
      r+=gxlate[p[i].g];
      r+=bxlate[p[i].b];
      sp[i]=r;
   }
} /* gr_pack */

#ifdef	__BORLANDC__
int  gr_key(void) {
_asm	{
	mov	ah,1
	int	16h
	mov	ax,0
	jz	_asd
	int	16h
	or	al,al
	jz	_asd
	mov	ah,0
}
_asd:;
   return _AX;
}
#endif
