#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include "gr.h"

#include "cam.h"
#include "vox.h"

#define	RESOLUTION	1

#define	NC	400
#define	MAXC	20
#define	TMAX	TRANSPFULL/4
#define	NT	50

int width=0,height=0,mode=-1;
#pragma	argsused
static int enumerator(int wid,int hig,int rbits,int gbits,int bbits,
		       int pages,int code) {
   int remember=0;
   if(width<wid) {
      remember=1;
   } else if(width==wid) { remember=1;}
   if(remember) {
      width=wid; height=hig; mode=code;
   }
   return 1;
} /* enumerator */

void add_test_voxel(colorinfo *color,transpinfo transp,
                    longint x,longint y,longint z) {
   if(!oct_addatom(x,y,z,color,transp)) {
      printf("Error adding atomic voxel!\n"); exit(2);
   }
} /* add_test_voxel */
static colorinfo purered={MAXCOLORCOMP,0,0},
                 puregreen={0,MAXCOLORCOMP,0},
                 pureblue={0,0,MAXCOLORCOMP},
                 purewhite={MAXCOLORCOMP,MAXCOLORCOMP,MAXCOLORCOMP};
#define	NCOLORS	4
                 *colors[]={&purered,&puregreen,&pureblue,&purewhite,0};
void add_test_voxels(void) {
   longint x,y,z;
   int t;
   int i,j;
   for(i=0;i<NC;i++) {
      x=random(MAXC)*2-MAXC;
      y=random(MAXC)*2-MAXC;
      z=random(MAXC)*2-MAXC;
      t=0;
      for(j=0;j<4;j++) t+=random(NT*2);
      t/=j; t=t-NT; if(t<0) t=-t;
      t=(t)*TMAX/(NT);
      add_test_voxel(colors[i%NCOLORS],t,x,y,z);
   }
   oct_update();
} /* add_test_voxels */
void draw_test_scene(void) {
   dvec3 pos,fwd,up;
   cam_getview(&pos,&fwd,&up);
   vox_view(&pos,&fwd,&up);
   vox_reset();
   ov_subdivide(&fwd,RESOLUTION);
   vox_draw();
cprintf("%lf,%lf,%lf\r",pos[0],pos[1],pos[2]);
   gr_redraw();
} /* draw_test_scene */

#define	ROTSPEED	1
void test_drawing(void) {
   int done=0,k,speed=0;
   while(!done) {
      cam_move(speed);
      draw_test_scene();
      do {
         k=gr_key();
         switch(k) {
            case 0x1b:
            case '`': case '~': done=1; break;
            case '+': speed++; break;
            case '-': speed--; break;
            case '/': speed=0; break;
            case 's': case 'S': cam_rotate(0,0, ROTSPEED); break;
            case 'f': case 'F': cam_rotate(0,0,-ROTSPEED); break;
            case 'e': case 'E': cam_rotate( ROTSPEED,0,0); break;
            case 'd': case 'D': cam_rotate(-ROTSPEED,0,0); break;
            case 'P': case 'p': if(!gr_shot()) printf("\b\b\b"); break;
            default: break;
         }
      } while(k);
   }
} /* test_drawing */

void main(void) {
   gr_enummodes(&enumerator);
   if(mode<0) { printf("No graphic modes!\n"); exit(1); }
   if(!vox_init(60,width,height)) { printf("Error initializing renderer!\n"); exit(1);}
   if(!oct_init(10000)) { printf("Error initializing octree!\n"); exit(1);}
   add_test_voxels();
   cam_init(0,0,-100);
   cam_rotate(ROTSPEED*0,0,0);
   if(!gr_open(mode)) { printf("Error initializing graphics!\n"); exit(1); }
   test_drawing();
   gr_close();
   oct_done();
   vox_done();
   exit(0);
} /* main */
